Merge remote branch 'origin/7.8'
[mesa.git] / bin / mklib
index 0acaeb96eae0304402b4abd79a7c7c8934a625a7..c2760e5d892724b0c6a065695c1f3752605ab43f 100755 (executable)
--- a/bin/mklib
+++ b/bin/mklib
 # CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 
 
+# Clear CDPATH as the 'cd' command will echo stuff
+# to stdout if it is set
+unset CDPATH
+
 # Given a list of files, look for .a archives and unpack them.
 # Return the original list of files minus the .a files plus the unpacked files.
+# first param:  name of a temp directory (to be deleted when finished)
+# remaining params:  list of .o and .a files
 expand_archives() {
+    DIR=$1
+    shift
     FILES=$@
     NEWFILES=""
+    ORIG_DIR=`pwd`
+    mkdir -p "$DIR"
+    cd "$DIR"
     for FILE in $FILES ; do
         case $FILE in
             *.a)
                 # extract the .o files from this .a archive
+                case $FILE in
+                    /*) ;;
+                    *)  FILE="$ORIG_DIR/$FILE" ;;
+                esac
                 MEMBERS=`ar t $FILE`
                 ar x $FILE
-                NEWFILES="$NEWFILES $MEMBERS"
+                for MEMBER in $MEMBERS ; do
+                    NEWFILES="$NEWFILES $DIR/$MEMBER"
+                done
                 ;;
             *)
                 # other file type, just add to list
@@ -44,27 +61,7 @@ expand_archives() {
                 ;;
         esac
     done
-    echo $NEWFILES
-}
-
-
-# Given a list of files, look for .a archives and return a list of all objects
-# in the .a archives.
-contents_of_archives() {
-    FILES=$@
-    NEWFILES=""
-    for FILE in $FILES ; do
-        case $FILE in
-            *.a)
-                # get list of members in this .a archive
-                MEMBERS=`ar t $FILE`
-                NEWFILES="$NEWFILES $MEMBERS"
-                ;;
-            *)
-                # skip other file types
-                ;;
-        esac
-    done
+    cd "$ORIG_DIR"
     echo $NEWFILES
 }
 
@@ -360,13 +357,13 @@ case $ARCH in
             fi
 
            # expand .a into .o files
-           NEW_OBJECTS=`expand_archives $OBJECTS`
+           NEW_OBJECTS=`expand_archives ${LIBNAME}.obj $OBJECTS`
 
             # make static lib
            FINAL_LIBS=`make_ar_static_lib ${OPTS} 1 ${LIBNAME} ${NEW_OBJECTS}`
 
            # remove temporary extracted .o files
-           rm -f `contents_of_archives $OBJECTS`
+           rm -rf ${LIBNAME}.obj
         else
            # make dynamic library
            LIBNAME="lib${LIBNAME}"     # prefix with "lib"
@@ -429,7 +426,7 @@ case $ARCH in
         if [ $STATIC = 1 ] ; then
            LIBNAME="lib${LIBNAME}.a"
            echo "mklib: Making SunOS static library: " ${LIBNAME}
-           FINAL_LIBS=`make_ar_static_lib -ruv 0 ${LIBNAME} ${OBJECTS}`
+           FINAL_LIBS=`make_ar_static_lib -ruc 0 ${LIBNAME} ${OBJECTS}`
        else
            if [ $NOPREFIX = 0 ] ; then
                LIBNAME="lib${LIBNAME}.so"
@@ -497,13 +494,16 @@ case $ARCH in
                OPTS="${OPTS} -Wl,-Mmapfile.scope"
            fi
 
-           # Check if objects are SPARC v9
+           # Check if objects are 64-bit
            # file says: ELF 64-bit MSB relocatable SPARCV9 Version 1
            set ${OBJECTS}
            if [ ${LINK} = "cc" -o ${LINK} = "CC" ] ; then
-               SPARCV9=`file $1 | grep SPARCV9`
-               if [ "${SPARCV9}" ] ; then
-                   OPTS="${OPTS} -xarch=v9"
+               ABI64=`file $1 | grep "ELF 64-bit"`
+               if [ "${ABI64}" ] ; then
+                   case `uname -p` in
+                       sparc)      OPTS="${OPTS} -xarch=v9" ;;
+                       i386)       OPTS="${OPTS} -xarch=amd64" ;;
+                   esac
                fi
            fi
             if [ "${ALTOPTS}" ] ; then
@@ -553,12 +553,12 @@ case $ARCH in
            echo "mklib: Making FreeBSD static library: " ${STLIB}
 
            # expand .a into .o files
-           NEW_OBJECTS=`expand_archives $OBJECTS`
+           NEW_OBJECTS=`expand_archives ${STLIB}.obj $OBJECTS`
 
            FINAL_LIBS=`make_ar_static_lib cq 1 ${STLIB} ${NEW_OBJECTS}`
 
            # remove temporary extracted .o files
-           rm -f `contents_of_archives $OBJECTS`
+           rm -rf ${STLIB}.obj
        else
            # make dynamic library
            SHLIB="lib${LIBNAME}.so.${MAJOR}"
@@ -746,12 +746,20 @@ case $ARCH in
         if [ $STATIC = 1 ] ; then
             LIBNAME="lib${LIBNAME}.a"
             echo "mklib: Making Darwin static library: " ${LIBNAME}
-            LINK="ar"
             OPTS="-ruvs"
             if [ "${ALTOPTS}" ] ; then
                 OPTS=${ALTOPTS}
             fi
-            ${LINK} ${OPTS} ${LIBNAME} ${OBJECTS}
+
+            # expand .a into .o files
+            NEW_OBJECTS=`expand_archives ${LIBNAME}.obj $OBJECTS`
+
+            # make static lib
+            FINAL_LIBS=`make_ar_static_lib ${OPTS} 1 ${LIBNAME} ${NEW_OBJECTS}`
+
+            # remove temporary extracted .o files
+            rm -rf ${LIBNAME}.obj
+
             FINAL_LIBS=${LIBNAME}
         else
             # On Darwin a .bundle is used for a library that you want to dlopen
@@ -943,7 +951,14 @@ case $ARCH in
             if [ "${ALTOPTS}" ] ; then
                 OPTS=${ALTOPTS}
             fi
-            FINAL_LIBS=`make_ar_static_lib ${OPTS} 1 ${LIBNAME} ${OBJECTS}`
+
+            # expand .a into .o files
+            NEW_OBJECTS=`expand_archives ${LIBNAME}.obj $OBJECTS`
+
+            FINAL_LIBS=`make_ar_static_lib ${OPTS} 1 ${LIBNAME} ${NEW_OBJECTS}`
+
+            # remove temporary extracted .o files
+            rm -rf ${LIBNAME}.obj
         else
            OPTS="-shared -Wl,--enable-auto-image-base -Wl,-export-all -Wl,--out-implib=${LIBNAME}-${MAJOR}.dll.a"
             if [ "${ALTOPTS}" ] ; then
@@ -965,6 +980,11 @@ case $ARCH in
 
             # make lib
             ${LINK} ${OPTS} ${LDFLAGS} -o ${CYGNAME}-${MAJOR}.dll ${OBJECTS} ${DEPS}
+            # make build fail if link failed
+            es=$?
+            if [ "$es" -ne "0" ]; then
+                exit $es
+            fi
             # make usual symlinks
             ln -s ${LIBNAME}-${MAJOR}.dll.a ${LIBNAME}.dll.a
             # finish up